/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	StartLearningBusinessAction
//	変更履歴
//		2004.02.01	新規作成
//      2006.12.18  エンジン存在チェックからapplication
//                  設定まで同期を取る 
//

package jp.co.ntt.lms.lo.scorm.engine;

import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import jp.co.ntt.lms.lo.util.UserIDFolder;
import jp.co.ntt.lms.lo.scorm.util.Authentication;
import jp.co.ntt.lms.lo.scorm.util.Debug;
import jp.co.ntt.lms.lo.scorm.util.SG;
import jp.co.ntt.lms.lo.scorm.util.XMLUtil;
import jp.co.ntt.lms.lo.scorm.util.XPathUtil;
import jp.co.ntt.lms.xms.framework.XmsBusinessAction;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsSystemException;

import org.w3c.dom.Document;

/**
 *	StartLearningBusinessAction クラス<BR>
 *	学習開始を行うクラス<BR>
 */
public class StartLearningBusinessAction extends XmsBusinessAction {
	/**
	 * デフォルトコンストラクタ
	 */
	public StartLearningBusinessAction() {}

	/**
	 * 初期化処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 */
	protected void initProcessRequest(XmsRequest xmsRequest) throws XmsException {}

	/**
	 * 学習開始処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 * @param	xmsResponse	レスポンスオブジェクト
	 */
	protected void processRequest(XmsRequest xmsRequest, XmsResponse xmsResponse) throws XmsException {
		try {
			HttpServletRequest request = xmsRequest.getRequest();
			HttpSession session = request.getSession();
			ServletContext application = session.getServletContext();

			// 起動パラメータを作成する
			ExecuteParameters executeParameters = new ExecuteParameters();

			executeParameters.initialize(xmsRequest);

			// 認証を行う
			if (!Authentication
				.authenticate(
					executeParameters.getUserID(),
					executeParameters.getLOID(),
					xmsRequest.getParameter("AuthKey"))) {

				xmsResponse.setBusinessBean(new ExecuteErrorBusinessBean(executeParameters));
				xmsResponse.setBusinessStatus("AuthenticationError");
				return;
			}

			// エンジンをapplicationに存在するかどうかをチェックする
			String engineKeyName =
				"SCORM." + executeParameters.getUserID() + "." + executeParameters.getLOID() + ".ENGINE";
			////////////////////////////////////////////////
			// '06.12.18 synchronized用syncEngine追加 from
			////////////////////////////////////////////////
			String tmpEngine = engineKeyName + ".start";
			String syncEngine = tmpEngine.intern();
			synchronized(syncEngine) {
				// エンジンがapplicationに存在する場合
				if (application.getAttribute(engineKeyName) != null) {
					xmsResponse.setBusinessBean(new ExecuteErrorBusinessBean(executeParameters));
					xmsResponse.setBusinessStatus("MultipleExecute");
					return;
				}
				
				// 中断情報 + 教材構造をXMSⅡから受信する
				StringBuffer stduyInfoURL = new StringBuffer();
				
				stduyInfoURL.append(executeParameters.getStudyInfoURL());
				stduyInfoURL.append("?USERID=");
				stduyInfoURL.append(executeParameters.getUserID());
				stduyInfoURL.append("&LOID=");
				stduyInfoURL.append(executeParameters.getLOID());
				stduyInfoURL.append("&StudySession=");
				stduyInfoURL.append(executeParameters.getStudySessionCount());
				stduyInfoURL.append("&COMD=");
				stduyInfoURL.append(executeParameters.getStartCommand());
				stduyInfoURL.append("&AuthKey=");
				stduyInfoURL.append(
						Authentication.createKey(
								null,
								executeParameters.getUserID(),
								executeParameters.getLOID(),
								SG.get("ManagerName")));
				
				Document doc;
				
				try {
					doc = XMLUtil.newDocumentBuilder(false).parse(stduyInfoURL.toString());
				}
				catch (Exception ex) {
					Debug.write(ex);
					
					ExecuteErrorBusinessBean executeErrorBusinessBean = new ExecuteErrorBusinessBean(executeParameters);
					
					executeErrorBusinessBean.setException(ex);
					
					xmsResponse.setBusinessBean(executeErrorBusinessBean);
					xmsResponse.setBusinessStatus("ExecuteError");
					return;
				}
				
				// 取得結果をチェックする
				String status;
				
				status = XPathUtil.selectSimpleSingleNode(doc.getDocumentElement(), "status/text()").getNodeValue();
				
				// 認証エラーが発生した場合
				if (status.equals("1")) {
					xmsResponse.setBusinessBean(new ExecuteErrorBusinessBean(executeParameters));
					xmsResponse.setBusinessStatus("AuthenticationError");
					return;
				}
				// その他のエラーが発生した場合
				else if (status.equals("2")) {
					xmsResponse.setBusinessBean(new ExecuteErrorBusinessBean(executeParameters));
					xmsResponse.setBusinessStatus("ExecuteError");
					return;
				}
				// 上記以外のエラー
				else if (!status.equals("0")) {
					xmsResponse.setBusinessBean(new ExecuteErrorBusinessBean(executeParameters));
					xmsResponse.setBusinessStatus("ExecuteError");
					return;
				}
				
				// 教材構造をDOM Documentにする
				Document manifest =
					XMLUtil.createDocument(XPathUtil.selectSingleChildNode(doc.getDocumentElement(), "manifest"), false);
				
				// 中断情報をDOM Documentにする
				Document resume = null;
				
				// 再開時のみ中断情報を取得する
				if (executeParameters.getStartCommand().equals("CONT")) {
					// 中断情報をDOM Documentにする
					resume =
						XMLUtil.createDocument(
								XPathUtil.selectSingleChildNode(doc.getDocumentElement(), "resume"),
								false);
				}
				
				// エンジンを作成する
				Engine engine = new Engine(executeParameters);
				
				// エンジンを初期化する
				try {
					engine.initialize(manifest, resume);
				}
				catch (Exception ex) {
					Debug.write(ex);
					
					ExecuteErrorBusinessBean executeErrorBusinessBean = new ExecuteErrorBusinessBean(executeParameters);
					
					executeErrorBusinessBean.setException(ex);
					
					xmsResponse.setBusinessBean(executeErrorBusinessBean);
					xmsResponse.setBusinessStatus("ExecuteError");
					return;
				}
				
				// navtrace.xmlのファイルを作成し、xml宣言を追加する
				StringBuffer navtraceLogFile = new StringBuffer();
				
				navtraceLogFile.append(userIDPath(SG.get("ResumeDataBaseURL"), executeParameters.getUserID()));
				navtraceLogFile.append(File.separator);
				navtraceLogFile.append(executeParameters.getLOID());
				navtraceLogFile.append(File.separator);
				navtraceLogFile.append(executeParameters.getStudySessionCount());
				navtraceLogFile.append(File.separator);
				navtraceLogFile.append(executeParameters.getLaunchCount());
				navtraceLogFile.append(File.separator);
				
				// navtrace.xmlを格納するフォルダが存在しない場合は作成する
				File file = new File(navtraceLogFile.toString());
				
				if (!file.exists()) {
					file.mkdirs();
				}
				
				navtraceLogFile.append("navtrace.xml");
				
				PrintWriter pw = new PrintWriter(new FileWriter(navtraceLogFile.toString()));
				
				try {
					pw.println("<?xml version=\"1.0\" encoding=\"" + SG.get("XMLEncoding") + "\"?>");
				}
				finally {
					pw.close();
				}
				
				// タイムアウト監視クラス、起動パラメータ、api adapterをsessionに設定する
				session.setAttribute("SCORM.TIMEOUT_WATCHER", new TimeoutWatcher(executeParameters));
				session.setAttribute("SCORM.EXECUTE_PARAMETERS", executeParameters);
				session.setAttribute("SCORM.API_ADAPTER", new SCORMAPIAdapter(executeParameters));
				
				// エンジンをapplicationに設定する
				application.setAttribute(engineKeyName, engine);
				
				xmsResponse.setBusinessBean(new StartLearningBusinessBean(executeParameters));
			}
			////////////////////////////////////////////////
			// '06.12.18 synchronized用syncEngine追加 to
			////////////////////////////////////////////////
		}
		catch (Exception ex) {
			throw new XmsSystemException(ex);
		}
	}

	private static String userIDPath(String strDirPath, String strUserID)
	{
		return UserIDFolder.getPath(strDirPath, strUserID);
	}
}
